package org.once.serviceChoicer.candidate.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.once.serviceChoicer.candidate.ICandidate;
import org.once.serviceChoicer.candidate.IRule;
import org.once.serviceChoicer.input.qos.IQoSAttr.Type;

public class Candidate implements ICandidate{
	
	private String name; //db1
	private String type; //db
	private String serviceID; // bpmnͼϷӦĽڵ
	private String wsdlAddr;
	public  Map<String, String> attrMap;
	private List<IRule> rules = new ArrayList<IRule>();
	
	public Candidate(String type, String name, String serviceID){
		this.type = type;
		this.name = name;
		this.serviceID = serviceID;
		this.attrMap = new HashMap<String, String>();
	}

	public String getName() {
		return this.name;
	}
	
	public String getWsdlAddr(){
		return this.wsdlAddr;
	}
	
	public void setWsdlAddr(String wsdlAddr){
		this.wsdlAddr = wsdlAddr;
	}
	
	@Override
	public String getType() {
		return this.type;
	}
	public void setRules(Type property,double value,String dep){
		Rule r=new Rule(value,dep);
		r.property=property;
		rules.add(r);
	}

	public List<IRule> getRules(Type type) {
		List<IRule> returnRules = new ArrayList<IRule>();
		for(int i=0; i<rules.size();i++){
			if(((Rule)rules.get(i)).property==type){
				returnRules.add(rules.get(i));
			}
		}
		return returnRules;
	}
	
	public String toString(){
		return this.name;
	}

	@Override
	public List<IRule> getAllRules() {
		return rules;
	}

	@Override
	public boolean equals(Object obj) {
		if(obj!=null && obj instanceof ICandidate){
			ICandidate objC = (ICandidate) obj;
			if(objC.getType().equals(type)&& objC.getName().equals(name)){
				return true;		
			}
		}
		return false;
	}
	
	public int hashCode()   {
		int result = 17;
        result = 37 * result + type.hashCode();
        result = 37 * result + name.hashCode();
        return result;

	}

	@Override
	public String getServiceID() {
		return this.serviceID;
	}
	
	public ICandidate clone(){
		Candidate cand = new Candidate(this.type,this.name,this.serviceID);
		cand.setWsdlAddr(this.wsdlAddr);
		return (ICandidate)cand;
	}
}
