package org.once.serviceChoicer.math.impl;

import org.once.serviceChoicer.candidate.ICandidate;
import org.once.serviceChoicer.input.process.IEPath;
import org.once.serviceChoicer.input.qos.IQoSAttr;
import org.once.serviceChoicer.math.IVariable;

public class Variable implements IVariable{
	
	private String name;
	private static int num = 0;
	private Type type;
	
	private static int num2 = 0;
	
	
	public Variable(){
		num2++;
		name = "var_" + num2;
		type = Type.FREE;
	}
	
	public Variable(IEPath epath, IQoSAttr.Type type){
		name = "e" + epath.getPathNo()+ "_" + type.name().toLowerCase().substring(0,1);
		this.type = Type.FREE;
	}
	
	public Variable(ICandidate candidate){
		name = "X" + candidate.getName().toLowerCase()+"_"+candidate.getServiceID();
		this.type = Type.BIN;
	}

	public Variable(Monomial monomial) {
		num++;
		name = "Y" + num; 
		this.type = Type.BIN;
	}

	public Variable(IQoSAttr.Type type, boolean isScore) {
		if(isScore){
			name = "Score" + type.toString().substring(0,3);
			this.type = Type.DEFAULT;
		}else{
			name = type.toString();
			this.type = Type.FREE;
		}
	
	}

	public boolean canSame(IVariable var) {
		if(this.name.equals(var.getName()))
			return true;
		else
			return false;
	}
	
	public String toString(){
		return this.name;
	}

	public String getName() {
		return this.name;
	}
	
	public IVariable clone(){
		Variable obj = null;
		try {
			obj = (Variable) super.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		obj.name = this.name;
		return obj;
	}

	@Override
	public Type getType() {
		return this.type;
	}
	
	public boolean equals(IVariable var){
		if(var == null)
			return false;
		if(var.getName().equals(this.name))
			return true;
		
		return false;
	}
}
