package org.once.serviceChoicer.qosDescrip2.parser.impl;

import org.once.serviceChoicer.qosDescrip2.token.IToken;
import org.once.serviceChoicer.qosDescrip2.token.IToken4log;
import org.once.serviceChoicer.qosDescrip2.token.IToken4log.Type;


public class RelationTableTest4log {

	private Type[] typeList = {Type.AND, Type.OR, Type.NOT, Type.L,Type.R,Type.ID};
	private byte[][] relationTable= {
		{1,1,0,0,1,0,},
		{0,1,0,0,1,0},
		{1,1,1,0,1,0},
		{0,0,0,0,2,0},
		{1,1,1,1,1,1},
		{1,1,1,1,1,-1}
	};
	
	public enum Relation {LT, GT, EU};
	
	public RelationTableTest4log(){
		
	}
	
	public RelationTableTest4log(Type[] typeList, byte[][] relationTable){
		this.typeList = typeList;
		this.relationTable = relationTable;
	}
	
	
	public Relation getRelation(IToken4log tokenTest, IToken token){
		if(tokenTest.getType()== token.getType() && tokenTest.getType() == Type.END){
//			System.out.println("over");
			return null;
		}
		
		if(tokenTest.getType() == Type.END)
			return Relation.LT;
		if(token.getType() == Type.END)
			return Relation.GT;
		
		if(tokenTest.getType() == Type.NON_FINAL || token.getType() == Type.NON_FINAL)
			return Relation.EU;
		
		int li = -1, ri = -1;
		for(int i = 0; i < typeList.length; i++){
			if(typeList[i] == tokenTest.getType())
				li = i;
			if(typeList[i] == token.getType())
				ri = i;
		}
		
		switch(relationTable[li][ri]){
		case 0:
			return Relation.LT;
		case 1:	
			return Relation.GT;
		case 2:
			return Relation.EU;
		default:
			System.out.println("ERROR");
			return null;
		}
	}
}
