package org.once.serviceChoicer.system.impl;

import org.once.serviceChoicer.exception.ServiceChoicerException;
import org.once.serviceChoicer.input.process.IProcess;
import org.once.serviceChoicer.input.qos.IQoSAttr.Type;
import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.math.IVariable;
import org.once.serviceChoicer.math.impl.Polynomial;
import org.once.serviceChoicer.output.IVarManager;
import org.once.serviceChoicer.system.ICaculModle;
import org.once.serviceChoicer.input.process.IEPath;

public class EPathQoS implements ICaculModle{
	
	private IProcess process;
	private IVarManager varManager;
	private Type type;
	
	public EPathQoS(IProcess process, IVarManager varManager){
		this.process = process;
		this.varManager = varManager;
	}
	
	public void setType(Type type){
		this.type = type;
	}
	
	@Override
	public IPolynomial getPNomial() throws ServiceChoicerException {
		IPolynomial result = new Polynomial();
		for(IEPath epath : process.getEPathes()){
			IVariable var = varManager.getVar(epath, type);
			IPolynomial item = new Polynomial(var).multiCoef(epath.getProbobility());
			result = result.add(item);
		}
		return result;
	}
	
	public static void main(String[] args){
		
	}

}
