package org.once.serviceChoicer.system.impl;

import java.util.ArrayList;
import java.util.List;

import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.math.IVariable;
import org.once.serviceChoicer.math.impl.Monomial;
import org.once.serviceChoicer.math.impl.Polynomial;
import org.once.serviceChoicer.output.IConstrain;
import org.once.serviceChoicer.output.IVarManager;
import org.once.serviceChoicer.output.IConstrain.OPType;
import org.once.serviceChoicer.output.impl.LinerConstrain;
import org.once.serviceChoicer.system.ILiner;

public class Liner implements ILiner{
	
	private IVarManager varManager;
	private List<IConstrain> linerConstrains;
	
	public Liner(IVarManager varManager){
		this.varManager = varManager;
		linerConstrains = new ArrayList<IConstrain>();
	}
	
	
	public List<IConstrain> constrainLiner(IConstrain constrain) {
		IPolynomial pn = constrain.getLeft();
		pn.unit();
		for(int i = 0; i < pn.getMList().size(); i++){
			Monomial monomial = pn.getMList().get(i);
			if(monomial.uk() > 1){
				
				// Ի
				if(! varManager.containsKey(monomial)){
					
					List<IVariable> aList = monomial.getVarList();
					IPolynomial subPn = new Polynomial(aList.get(0));
					for(int j = 1; j < aList.size(); j++)
						subPn.add(new Polynomial(aList.get(j)));				
					IVariable var = varManager.getVar(monomial);
					IPolynomial pn1 = subPn.clone().add(new Polynomial(var).multiCoef(-1));
					IPolynomial pn2 = new Polynomial(var).multiCoef(monomial.uk()).add(subPn.clone().multiCoef(-1));

					this.linerConstrains.add(new LinerConstrain(pn1, OPType.LT, monomial.uk()-1));
					this.linerConstrains.add(new LinerConstrain(pn2, OPType.LT, 0));
				}
				IVariable var = varManager.getVar(monomial);
				monomial.setVar(var);
			}
		}
		return this.linerConstrains;
	}

}
